<?php

/**
 * 
 * Default GSALES 2 PDF Letter Template
 * Author: GSALES Development Team - Gedankengut GbR Manuel Häuser & Gökhan Sirin
 * 
 * http://www.gsales.de
 * http://www.gedankengut.de
 * 
 * Copyright 2013 - Gedankengut GbR
 * 
 * Damit GSALES Updates nicht die eigenen Änderungen überschreiben, sollte diese Datei kopiert (tpl.meinName.php) und dann auf die eigenen Bedürfnisse angepasst werden!
 * Die Weitergabe von modifizierten Rechnungstemplates an andere GSALES Benutzer über unser Supportforum (http://forum.gsales.de) ist gestattet.
 * 
 */


// PDF Datei als Briefpapier hinterlegen? (empfohlen)

	/*
		Um das optimale Ergebnis zu erzielen lege Texte und wenn möglich dein Firmenlogo in der Vorlage als Vektoren an.
		Dadurch erhälst du bei Zoomen eine gleichbleibende Qualität und die Dateigröße deiner Rechnungen bleibt schön klein was beim Versand per E-Mail
		ein wichtiger Faktor ist.
	*/
	
$arrPDFConfig['use_stationery_pdf'] = $this->refCore->cfg->v('pdf_letter_stationary');
$arrPDFConfig['stationery_pdf_file'] = $this->refCore->cfg->v('path_absolute').$this->refCore->cfg->v('pdf_letter_stationary_file'); # bitte pdf Datei entsprechend hochladen!


// Mini Absender
$arrPDFConfig['print_minisender'] = $this->refCore->cfg->v('pdf_letter_printminisender');


// Firmenlogo einbinden

	/*
		Achtung! Möglich sind folgende Dateiformate
		- JPG Bilder (Graustufenbilder, Truecolor 24 Bit, CMYK 32 Bit)
		- PNG Bilder (Graustufenbilder 8 Bit & 256 Graustufen, Farbpaletten, Truecolor 24 Bit)
	*/
	
$arrPDFConfig['use_picture'] = $this->refCore->cfg->v('pdf_letter_picture');
$arrPDFConfig['picture_file'] = $this->refCore->cfg->v('path_absolute').$this->refCore->cfg->v('pdf_letter_picture_file'); # GSALES Logo als Beispiel, bitte eigene Verwenden damit diese bei Updates nicht versehentlich überschrieben wird
$arrPDFConfig['picture_width'] = $this->refCore->cfg->v('pdf_letter_picture_width');
$arrPDFConfig['picture_posX'] = $this->refCore->cfg->v('pdf_letter_picture_posx');
$arrPDFConfig['picture_posY'] = $this->refCore->cfg->v('pdf_letter_picture_posy');


// Fußzeilenblöcke

$arrPDFConfig['print_footer_blocks'] = $this->refCore->cfg->v('pdf_letter_printfooter');


// Fußzeilenblöcke Content (verwendet den Konfigurationsreiter "Meine Daten")

if ($this->refCore->cfg->v('me_ustidnr') != '' && $this->refCore->cfg->v('me_taxno')){
	$arrTaxFooter = array('headline'=>'Steuernummern', 'txt'=>'USt-IdNr. '.$this->refCore->cfg->v('me_ustidnr')."\nSt.-Nr. ".$this->refCore->cfg->v('me_taxno'));	
} else {
	if ($this->refCore->cfg->v('me_ustidnr') != '') $arrTaxFooter = array('headline'=>'USt-IdNr.', 'txt'=>$this->refCore->cfg->v('me_ustidnr'));
	else $arrTaxFooter = array('headline'=>'Steuernummer', 'txt'=>$this->refCore->cfg->v('me_taxno'));		
}

$arrContactFooter = array('headline'=>'Anschrift', 		'txt'=>$this->refCore->cfg->v('me_company')."\n".$this->refCore->cfg->v('me_address')."\n".$this->refCore->cfg->v('me_countrycode').$this->refCore->cfg->v('me_zip').' '.$this->refCore->cfg->v('me_city'));	
if ($this->refCore->cfg->v('me_owner') != '' || $this->refCore->cfg->v('me_manager') != '') $arrContactFooter['txt'] .= "\n";
if ($this->refCore->cfg->v('me_owner') != '') $arrContactFooter['txt'] .= "\n".'Inh. '.$this->refCore->cfg->v('me_owner');
if ($this->refCore->cfg->v('me_manager') != '') $arrContactFooter['txt'] .= "\n".'GF '.$this->refCore->cfg->v('me_manager');

$arrBankFooter = array('headline'=>'Bankverbindung', 'txt'=>'');
if ($this->refCore->cfg->v('me_bank') != '') $arrBankFooter['txt'] .= $this->refCore->cfg->v('me_bank')."\n";
if ($this->refCore->cfg->v('me_bankaccount') != '') $arrBankFooter['txt'] .= 'Konto '.$this->refCore->cfg->v('me_bankaccount')."\n";
if ($this->refCore->cfg->v('me_bankcode') != '') $arrBankFooter['txt'] .= 'BLZ '.$this->refCore->cfg->v('me_bankcode')."\n";
if ($this->refCore->cfg->v('me_bankiban') != '') $arrBankFooter['txt'] .= 'IBAN '.$this->refCore->cfg->v('me_bankiban')."\n";
if ($this->refCore->cfg->v('me_bankbic') != '') $arrBankFooter['txt'] .= 'BIC '.$this->refCore->cfg->v('me_bankbic')."\n";

// footer im GSALES 1 stil = textfelder aus konfiguration

$arrPDFConfig['footer_head_1'] = $this->refCore->cfg->v('pdf_footer_headline_1');
$arrPDFConfig['footer_1'] = $this->refCore->cfg->v('pdf_footer_1');
$arrPDFConfig['footer_head_2'] = $this->refCore->cfg->v('pdf_footer_headline_2');
$arrPDFConfig['footer_2'] = $this->refCore->cfg->v('pdf_footer_2');
$arrPDFConfig['footer_head_3'] = $this->refCore->cfg->v('pdf_footer_headline_3');
$arrPDFConfig['footer_3'] = $this->refCore->cfg->v('pdf_footer_3');
$arrPDFConfig['footer_head_4'] = $this->refCore->cfg->v('pdf_footer_headline_4');
$arrPDFConfig['footer_4'] = $this->refCore->cfg->v('pdf_footer_4');

// footer aus "meine daten"

$arrPDFConfig['arrFooter'] = array(
	$arrContactFooter,
	array('headline'=>'Kontakt', 		'txt'=>"Tel. ".$this->refCore->cfg->v('me_phone')."\nFax ".$this->refCore->cfg->v('me_fax')."\n".$this->refCore->cfg->v('me_mail')."\n".$this->refCore->cfg->v('me_web')),
	$arrTaxFooter,
	$arrBankFooter
);


// Schrift definieren

$arrPDFConfig['font'] = 'Arial';
$arrPDFConfig['font_size_tiny'] = 6; // Verwendung in Mini-Absender
$arrPDFConfig['font_size_small'] = 8;  // Verwendung in Fußzeilenblöcken
$arrPDFConfig['font_size_big'] = 14; // Verwendung in Dokumenten-Headline
$arrPDFConfig['font_size'] = 10; // Standardgröße für alles weitere


// Sonstige Einstellungen

$arrPDFConfig['offsetX'] = 24; // linker Rand
$arrPDFConfig['startAtY'] = 95; // Ab welcher Position geht es auf der ersten Seite los?
$arrPDFConfig['restartAtY'] = 51; // Ab welcher Position geht es nach einem Seitenumbruch auf der neuen Seite weiter?


// Bezugzeile

$arrPDFConfig['col1_label'] = $this->refCore->cfg->v('pdf_letter_col1_label');
$arrPDFConfig['col2_label'] = $this->refCore->cfg->v('pdf_letter_col2_label');
$arrPDFConfig['col3_label'] = $this->refCore->cfg->v('pdf_letter_col3_label');
$arrPDFConfig['col4_label'] = $this->refCore->cfg->v('pdf_letter_col4_label');


// Absender (kann auch über die GSALES Konfiguration beinflusst werden)

$arrPDFConfig['company_sender'] = $this->refCore->cfg->v('me_company').' - '.$this->refCore->cfg->v('me_address').' - '.trim($this->refCore->cfg->v('me_countrycode').' '.$this->refCore->cfg->v('me_zip')).' '.$this->refCore->cfg->v('me_city');

























// Ab hier: Entwicklermodus ;)




// Im Blanko keine Bilder, Briefpapier und Fußzeilenblöcke ausgeben
if ($booBlanko){
	$arrPDFConfig['use_stationery_pdf'] = false;
	$arrPDFConfig['use_picture'] = false;
	$arrPDFConfig['print_footer_blocks'] = false;
}




if (!class_exists('PDF_TEMPLATE_DEFAULT_LETTER')){ // klasse nur beim ersten einbinden deklarieren
	
	class PDF_TEMPLATE_DEFAULT_LETTER extends FPDI {

		public $pdfCfg;
		public $pdfData;


		// HTML PARSER - START
		// Very simple HTML Parsing Stuff
		// http://fpdf.org/en/script/script42.php

		//variables of html parser
		var $B;
		var $I;
		var $U;

		function WriteHTML($html)
		{
			//HTML parser
			$html=strip_tags($html,"<b><u><i><a><img><p><br><strong><em><font><tr><blockquote>"); //supprime tous les tags sauf ceux reconnus
			$html=str_replace("\n",' ',$html); //remplace retour à la ligne par un espace
			$a=preg_split('/<(.*)>/U',$html,-1,PREG_SPLIT_DELIM_CAPTURE); //éclate la chaîne avec les balises
			foreach($a as $i=>$e)
			{
				if($i%2==0)
				{
					//Text
					if($this->HREF)
						$this->PutLink($this->HREF,$e);
					else
						$this->Write(5,stripslashes($this->txtentities($e)));
				}
				else
				{
					//Tag
					if($e[0]=='/')
						$this->CloseTag(strtoupper(substr($e,1)));
					else
					{
						//Extract attributes
						$a2=explode(' ',$e);
						$tag=strtoupper(array_shift($a2));
						$attr=array();
						foreach($a2 as $v)
						{
							if(preg_match('/([^=]*)=["\']?([^"\']*)/',$v,$a3))
								$attr[strtoupper($a3[1])]=$a3[2];
						}
						$this->OpenTag($tag,$attr);
					}
				}
			}
		}

		function OpenTag($tag, $attr)
		{
			//Opening tag
			switch($tag){
				case 'B':
				case 'I':
				case 'U':
					$this->SetStyle($tag,true);
					break;
				case 'BR':
					$this->Ln(5);
					break;
				case 'P':
					$this->Ln(10);
					break;
			}
		}


		function CloseTag($tag)
		{
			// Closing tag
			if($tag=='B' || $tag=='I' || $tag=='U')
				$this->SetStyle($tag,false);
		}

		function SetStyle($tag, $enable)
		{
			//Modify style and select corresponding font
			$this->$tag+=($enable ? 1 : -1);
			$style='';
			foreach(array('B','I','U') as $s)
			{
				if($this->$s>0)
					$style.=$s;
			}
			$this->SetFont('',$style);
		}

		/*
		function PutLink($URL, $txt)
		{
			//Put a hyperlink
			$this->SetTextColor(0,0,255);
			$this->SetStyle('U',true);
			$this->Write(5,$txt,$URL);
			$this->SetStyle('U',false);
			$this->SetTextColor(0);
		}
		*/

		/*
		//function hex2dec
		//returns an associative array (keys: R,G,B) from
		//a hex html code (e.g. #3FE5AA)
		function hex2dec($couleur = "#000000"){
			$R = substr($couleur, 1, 2);
			$rouge = hexdec($R);
			$V = substr($couleur, 3, 2);
			$vert = hexdec($V);
			$B = substr($couleur, 5, 2);
			$bleu = hexdec($B);
			$tbl_couleur = array();
			$tbl_couleur['R']=$rouge;
			$tbl_couleur['V']=$vert;
			$tbl_couleur['B']=$bleu;
			return $tbl_couleur;
		}
		*/

		/*
		//conversion pixel -> millimeter at 72 dpi
		function px2mm($px){
			return $px*25.4/72;
		}
		*/


		function txtentities($html){
			$trans = get_html_translation_table(HTML_ENTITIES);
			$trans = array_flip($trans);
			return strtr($html, $trans);
		}




		// HTML PARSER - STOP



		function passConfiguration($arrConfig){
			$this->pdfCfg = $arrConfig;
		}
		
		function passGsalesData($arrData){
			$this->pdfData = $arrData;
		}
		
		
		function Header(){

			if($this->pdfCfg['use_stationery_pdf']){
				$this->setSourceFile($this->pdfCfg['stationery_pdf_file']);
				$intTempplateId = $this->ImportPage(1);
				$this->useTemplate($intTempplateId,0);
			}			
			
			/*
			// Development: XY Skala eindrucken
			$this->SetXY(0, 0);
			$this->SetFont($this->pdfCfg['font'], '', 4);
			for ($i=0;$i<300;$i+=3) {
				$this->SetXY($i,3); $this->Cell(3,3,$i);
				$this->SetXY(3,$i); $this->Cell(3,3,$i);
			}
			*/

			// Bild eindrucken
			
			if ($this->pdfCfg['use_picture']){
				$this->Image($this->pdfCfg['picture_file'], $this->pdfCfg['picture_posX'] , $this->pdfCfg['picture_posY'] , $this->pdfCfg['picture_width']);	
			}

			if ($this->PageNo() == 1){

				// Absender & Anschrift

				// Mini-Absender über Empfänger
				if ($this->pdfCfg['print_minisender']){
					$this->SetXY($this->pdfCfg['offsetX'],45);
					$this->SetFont($this->pdfCfg['font'], '', $this->pdfCfg['font_size_tiny']);
					$this->Cell(100,0,$this->pdfText($this->pdfCfg['company_sender']));
				}

				// Empfängeranschrift
				$this->SetXY($this->pdfCfg['offsetX'],50);
				$this->SetFont($this->pdfCfg['font'], '', $this->pdfCfg['font_size']);
				$this->MultiCell(100,5, $this->pdfText($this->pdfData['recipient_txt']),0,'L');

				$this->SetY($this->pdfCfg['startAtY']);

			} else {

				$this->SetY($this->pdfCfg['restartAtY']);

			}

		}

		function Footer(){
			
			if (false == $this->pdfCfg['print_footer_blocks']) return;
			
			// Fußzeilenblöcke ausgeben
			
			$arrFooter = $this->pdfCfg['arrFooter'];
			if (!is_array($arrFooter)) return false;

			// Footer überschreiben mit komplett manuellen Fußzeilenblöcken aus Konfiguration (GSALES 1 Stil)
			
			if ($this->pdfCfg['footer_1'] != '' || $this->pdfCfg['footer_2'] != '' || $this->pdfCfg['footer_3'] != '' || $this->pdfCfg['footer_4'] != '' || $this->pdfCfg['footer_5'] != ''){
				unset($arrFooter);
				for ($i=1;$i<=5;$i++) $arrFooter[] = array('headline'=> $this->pdfCfg['footer_head_'.$i], 'txt'=>$this->pdfCfg['footer_'.$i]);
			}
			
			$intYOffset = 270;
			$intXStart = 15;
			$intXStop = 230; // Diesen Wert modifizieren um die horizontale Verteilung der Fußzeilenblöcke zu beeinflussen
			$intCalculatedSpace = $intXStop-$intXStart;
			$intCalculatedSpacePerBlock = floor($intCalculatedSpace/5);

			foreach ((array)$arrFooter as $key => $value){
				$this->SetXY($intXStart+($key*$intCalculatedSpacePerBlock), $intYOffset);
				$this->SetFont($this->pdfCfg['font'], 'B', 7);
				$this->Cell($intCalculatedSpacePerBlock,0,$this->pdfText($value['headline']));

				$this->SetXY($intXStart+($key*$intCalculatedSpacePerBlock), $intYOffset+2);
				$this->SetFont($this->pdfCfg['font'], '', 7);
				$this->MultiCell($intCalculatedSpacePerBlock,3,$this->pdfText($value['txt']),0,'L');
			}
			
			//reset font settings
			$this->SetFont($this->pdfCfg['font'], '', $this->pdfCfg['font_size']);
		
		}

		function euroReplace($string){
			return str_replace('€',chr(128),$string);
		}

		function pdfText($string){
			$string = str_replace('&nbsp;',' ', $string); // html_entity decode funktioniert nicht ... wieso?
			if (function_exists('iconv')){
				$retString = iconv('utf8', 'cp1252', html_entity_decode($string,ENT_QUOTES));
				if ($retString == false) $retString = iconv('utf-8', 'cp1252', html_entity_decode($string,ENT_QUOTES)); // auf manchen systemen korrekterweise utf-8 anstelle von utf8
				if ($retString) return $retString;
			}
			return utf8_decode(html_entity_decode($this->euroReplace($string),ENT_QUOTES));
		}		

	}

}
	

$pdf = new PDF_TEMPLATE_DEFAULT_LETTER('P', 'mm', 'A4');

$pdf->B=0;
$pdf->I=0;
$pdf->U=0;

$pdf->SetAutoPageBreak(true, 35);

$pdf->passConfiguration($arrPDFConfig);
$pdf->passGSalesData($var_array);

$pdf->AddPage();

$pdf->SetXY($arrPDFConfig['offsetX'],$arrPDFConfig['startAtY']);
$tmpY = $pdf->GetY();




// Bezugzeile

$pdf->SetXY($arrPDFConfig['offsetX'],$tmpY);
$pdf->SetFont($arrPDFConfig['font'], 'B', $arrPDFConfig['font_size_small']);
$pdf->Cell(20,0,$pdf->pdfText($arrPDFConfig['col1_label']), 0, 0, 'L');

$pdf->SetXY($arrPDFConfig['offsetX']+30,$tmpY);
$pdf->SetFont($arrPDFConfig['font'], 'B', $arrPDFConfig['font_size_small']);
$pdf->Cell(20,0,$pdf->pdfText($arrPDFConfig['col2_label']), 0, 0, 'L');

$pdf->SetXY($arrPDFConfig['offsetX']+70,$tmpY);
$pdf->SetFont($arrPDFConfig['font'], 'B', $arrPDFConfig['font_size_small']);
$pdf->Cell(20,0,$pdf->pdfText($arrPDFConfig['col3_label']), 0, 0, 'L');

$pdf->SetXY($arrPDFConfig['offsetX']+105,$tmpY);
$pdf->SetFont($arrPDFConfig['font'], 'B', $arrPDFConfig['font_size_small']);
$pdf->Cell(20,0,$pdf->pdfText($arrPDFConfig['col4_label']), 0, 0, 'L');

$pdf->SetXY($arrPDFConfig['offsetX']+150,$tmpY);
$pdf->SetFont($arrPDFConfig['font'], 'B', $arrPDFConfig['font_size_small']);
$pdf->Cell(20,0,$pdf->pdfText('Datum'), 0, 0, 'L');

$tmpY = $pdf->GetY()+4;

$pdf->SetXY($arrPDFConfig['offsetX'],$tmpY);
$pdf->SetFont($arrPDFConfig['font'], '', $arrPDFConfig['font_size_small']);
$pdf->Cell(20,0,$pdf->pdfText($var_array['col1']), 0, 0, 'L');

$pdf->SetXY($arrPDFConfig['offsetX']+30,$tmpY);
$pdf->SetFont($arrPDFConfig['font'], '', $arrPDFConfig['font_size_small']);
$pdf->Cell(20,0,$pdf->pdfText($var_array['col2']), 0, 0, 'L');

$pdf->SetXY($arrPDFConfig['offsetX']+70,$tmpY);
$pdf->SetFont($arrPDFConfig['font'], '', $arrPDFConfig['font_size_small']);
$pdf->Cell(20,0,$pdf->pdfText($var_array['col3']), 0, 0, 'L');

$pdf->SetXY($arrPDFConfig['offsetX']+105,$tmpY);
$pdf->SetFont($arrPDFConfig['font'], '', $arrPDFConfig['font_size_small']);
$pdf->Cell(20,0,$pdf->pdfText($var_array['col4']), 0, 0, 'L');

$pdf->SetXY($arrPDFConfig['offsetX']+150,$tmpY);
$pdf->SetFont($arrPDFConfig['font'], '', $arrPDFConfig['font_size_small']);
$pdf->Cell(20,0,$pdf->pdfText(date('d.m.Y', strtotime($var_array['created']))), 0, 0, 'L');


// "HTML" Text

$pdf->setMargins(24,0,14);
$pdf->SetFont($arrPDFConfig['font'], '', $arrPDFConfig['font_size'] );
$pdf->WriteHTML($pdf->pdfText($var_array['l_txt']));


// PDF Datei schreiben

if ($booBlanko) $pdf->Output($savetoblanko,'F');
else  $pdf->Output($saveto,'F');

// Reset für den nächsten Durchgang (blanko modus)

unset($tmpY, $endeY);